      SUBROUTINE  DRAWSP (MAXNPT, MAXEL, KPRINT, NSKIP, LSKIP, ISUB, 
     1                    XN, XX, YN, YX, XLEN, YLEN, NTAPE, LN, IAXES)
C
C       ***  PLOT (AND SUB-PLOT) OF A 2D FINITE ELEMENT MESH  ****
C
      PARAMETER ( MXLINE = 9000, MXPTS = 1000, LNMAX = 9,
     1            PANGLE = 0.0, QANGLE = 90.0, AANGLE = 0.0, 
     2            BANGLE = 90.0, PORGIN = 0.5, QORGIN = 0.5, 
     3            PSPACE = 2., SIZEYN = 0.07, IPORT = 0 )
      COMMON /HEAD/  ATITLE(20)
      COMMON /POINT/ NECK1(2), NODES(LNMAX+1)
      COMMON /FIX/   NECK(2,MXLINE), JOIN(2,MXLINE), NPQ(MXPTS), 
     1               NAB(MXPTS), IC(MXPTS)
      COMMON /FLOAT/ P(MXPTS+2), Q(MXPTS+2), A(MXPTS+2), B(MXPTS+2)
      DIMENSION      XX(ISUB), XN(ISUB), YX(ISUB), YN(ISUB)
C     A,B,NAB,IC USED ONLY FOR SUB PLOTS    NAB .LE. NUMNPT
C     MXLINE = MAX. NO. OF LINES TO BE PLOTTED
C     LN     = NUMBER OF NODES PER ELEMENT      .LE. LNMAX
C     MAXNPT = NO. NODAL PTS.
C     MAXEL  = NO.ELEMENTS
C     KPRINT > 0 PRINT INPUT DATA
C     NSKIP  = INCREMENT IN NODE NO.S TO PLOT, 0 = NONE
C     LSKIP  = INCREMENT IN ELM. NO.S TO PLOT, 0 = NONE
C     IAXES  > 0, SHOW THE AXES
C     ISUB   = NO. OF SUB-PLOTS DESIRED
C     XN(J)  = XMIN FOR SUB-PLOT WINDOW J
C     XX(J)  = XMAX FOR SUB-PLOT WINDOW J
C     YN(J)  = YMIN FOR SUB-PLOT WINDOW J
C     YX(J)  = YMAX FOR SUB-PLOT WINDOW J
C     NODE   = ELEM BOUNDARY CONNECTIONS NODE(1), NODE(2)
C              ,...NODE(LN), NODE(1)
      WRITE (6,*) 'BEGIN PLOTS'
      IF ( NTAPE .NE. 5 )  REWIND NTAPE
      IF ( LN .GT. LNMAX ) STOP 'NODES/ELEMENT TOO BIG IN DRAWSP'
      IF ( MAXNPT .GT. MXPTS )  STOP 'TOO MANY NODES IN DRAWSP'
      IF ( 2*MAXEL .GT. MXLINE )  STOP 'MXLINE TOO LOW, DRAWSP'
      IF ( ISUB .GT. 0 )  THEN
        DO 5  J = 1, MXPTS
  5     IC(J) = 0
      ENDIF
C     SET PLOT PARAMETERS
      PSCALE = XLEN
      ASCALE = XLEN
      QSCALE = YLEN
      BSCALE = YLEN
      CALL  PLOTS (IPORT,0,0,'VIEW2D')
C     SET NUMBER SIZE (INCREMENT OF .07) AND OFFSET
      OFFYN = 0.6*SIZEYN
      OFFXN = OFFYN
C     ESTABLISH NEW PEN ORIGIN
      IPEN = -3
      XP = PORGIN
      YP = QORGIN
      CALL  PLOT (XP,YP,IPEN)
   10 CONTINUE
      READ (NTAPE,5040)  (ATITLE(I),I=1,20)
 5040 FORMAT(20A4)
      IF ( KPRINT .GT. 0 ) WRITE (6,5050) (ATITLE(I),I=1,20)
 5050 FORMAT ( 20A4, /, '*** INPUT DATA ***', /, 'NODE',
     1         10X, 'X', 15X, 'Y' )
C      STORE NODE POINTS AND NODE NUMBERS
      NODE = 0
      DO 20  INPT = 1, MAXNPT
        READ (NTAPE,5060)  N, X, Y
 5060   FORMAT (I10, 10X, 2F10.4 )
        NODE = NODE + 1
        IF ( KPRINT .GT. 0 )  WRITE (6,5070) N,X,Y
 5070   FORMAT ( I5, 4X, 2(E10.4, 2X) )
        P(NODE)   = X
        Q(NODE)   = Y
        NPQ(NODE) = N
   20 CONTINUE
      LNODE = NODE
      IF ( KPRINT .GT. 0 ) WRITE (6,*) 
     1    'TOTAL NUMBER OF NODES = ', LNODE
      LINES = 0
      IF ( KPRINT .GT. 0 ) WRITE (6,5090)
 5090 FORMAT ( 'ELEMENT', 20X, 'NODES', /, 'NO.  I    J    K',
     1         '    L    M    N    O    P' )
C      FIND BUFFER LOCATIONS (IN XY) OF NODE POINTS AT THE
C          END OF EACH LINE TO BE DRAWN AND STORE IN NECK
C      SCALE THE DATA AND AND PLOT THE X-Y AXIS
C     SOME PLOTTERS REQUIRE EXTRA ARGUMENT IN SCALE AND AXIS
      CALL SCALE (P,PSCALE,LNODE,1)
      CALL SCALE (Q,QSCALE,LNODE,1)
      FIRSTX = P(LNODE+1)
      FIRSTY = Q(LNODE+1)
      DELTAX = P(LNODE+2)
      DELTAY = Q(LNODE+2)
      DELTAY = AMAX1 (DELTAX,DELTAY)
      DELTAX = DELTAY
      IF ( IAXES .GT. 0 )  THEN
        CALL AXIS (0.,0.,8HX VALUES,-8,PSCALE,PANGLE,FIRSTX,DELTAX)
        CALL AXIS (0.,0.,8HY VALUES,8,QSCALE,QANGLE,FIRSTY,DELTAY)
      ENDIF
      IF ( NSKIP .GT. 0 )  THEN
C        PLOT NODE NUMBERS FOR MAIN PLOT
        DO 40  IP = 1, MAXNPT, NSKIP
C          CALCULATE X & Y ,IN INCHES, OF POINT TO BE NUMBERED
          X   = (P(IP) - FIRSTX)/DELTAX + OFFXN
          Y   = (Q(IP) - FIRSTY)/DELTAY + OFFYN
          XYN = NPQ(IP)
          CALL  NUMBUR (X,Y,SIZEYN,XYN,PANGLE,-1)
C         CALL  NUMBER (X,Y,SIZEYN,XYN,PANGLE,'f5.2')
   40 CONTINUE
      ENDIF
      LEMENT = 0
      LPLOT  = 1
c     write(6,*) '150'
      DO 150  INEL =  1, MAXEL
c     write(6,*) '151'
        IF ( LN .LE. 4 )  READ (NTAPE,5100) NEL,(NODES(I),I=1,LN)
        IF ( LN .EQ. 6 )  READ (NTAPE,5100) NEL,NODES(1),NODES(3),
     1                    NODES(5),NODES(2),NODES(4),NODES(6)
        IF ( LN .EQ. 8 )  READ (NTAPE,5100) NEL,NODES(1),NODES(3),
     1                    NODES(5),NODES(7),NODES(2),NODES(4),
     2                    NODES(6),NODES(8)
        IF ( LN .EQ. 9 )  READ (NTAPE,5100) NEL,NODES(1),NODES(3),
     1                    NODES(5),NODES(7),NODES(2),NODES(4),
     2                    NODES(6),NODES(8),NODES(9)
 5100   FORMAT ( i5, 5x, 14I5)
        K      = LN
        IF ( LN .EQ. 9 )  K = 8
        IF ( NODES(4) .EQ. NODES(3) )  K = 3
        IF ( NODES(3) .EQ. NODES(2) )  K = 2
        LEMENT = LEMENT + 1
       IF ( KPRINT .GT. 0 )  THEN
        IF ( LN .LE. 4 )  WRITE (6,5110) NEL,(NODES(I),I=1,LN)
        IF ( LN .EQ. 6 )  WRITE (6,5110) NEL,NODES(1),NODES(3),
     1                    NODES(5),NODES(2),NODES(4),NODES(6)
        IF ( LN .EQ. 8 )  WRITE (6,5110) NEL,NODES(1),NODES(3),
     1                    NODES(5),NODES(7),NODES(2),NODES(4),
     2                    NODES(6),NODES(8)
        IF ( LN .EQ. 9 )  WRITE (6,5110) NEL,NODES(1),NODES(3),
     1                    NODES(5),NODES(7),NODES(2),NODES(4),
     2                    NODES(6),NODES(8),NODES(9)
 5110     FORMAT (16I5)
       ENDIF     
        IF ( LSKIP .EQ. 0 )  GO TO 60
C          PLOT ELEMENT NUMBER AT CENTROID OF ELEMENT
          IF ( LEMENT .NE. LPLOT )  GO TO 60
            X = 0.
            Y = 0.
            DO 50  I = 1, K
              G = K
              NODE = NODES(I)
              X = X + P(NODE)/G 
              Y = Y + Q(NODE)/G
   50       CONTINUE
C           DETERMINE POSITION IN INCHES
            X = (X-FIRSTX)/DELTAX + 3.*OFFXN
            Y = (Y-FIRSTY)/DELTAY + 3.*OFFYN
            XYN = LEMENT
            ANGEL = PANGLE + 30.
            CALL  NUMBUR (X,Y,SIZEYN,XYN,ANGEL,-1)
            LPLOT = LPLOT + LSKIP
   60     CONTINUE
          NODES(K+1) = NODES(1)
C
C     SEARCH JOIN TO SEE IF NODES I AND I+1 ARE ALREADY JOINED
C       JOIN(I,J) - CONTAINS THE NUMBERS OF THE NODES TO BE
C                      CONNECTED
C
      DO 140 I = 1, K
        IF ( LINES .EQ. 0 )  GO TO 90
          DO 80  N = 1, LINES
            DO 70 M = 1, 2
              IF ( JOIN(M,N) .NE. NODES(I) )  GO TO 70
                MM = M - 1
                IF ( MM .EQ. 0 )  MM = 2
                IF ( JOIN(MM,N) .NE. NODES(I+1) )  GO TO 70
                  GO TO 140
   70       CONTINUE
   80     CONTINUE
C     LOCATE BUFFER (XY) LOCATIONS OF NODES I AND I+1
   90   LOOP = 0
  100   NODE = NODES(I+LOOP)
        DO 110 J = 1, LNODE
          M = NPQ(J)
          IF ( M .NE. NODE )  GO TO 110
            LOOP = LOOP + 1
            NECK1(LOOP) = J
            IF ( LOOP .EQ. 1 )  GO TO 100
              GO TO 120
  110   CONTINUE
        WRITE (6,*) 'NODE ', NODE, ' DOES NOT EXIST'
        GO TO 140
C     STORE BUFFER (XY) LOCATIONS OF NODES I AND I+1 FOR THE 
C          LINES TO BE DRAWN IN PLOT ITYPE
C     STORE THE NODE NUMBERS IN JOIN
  120     LINES = LINES + 1
          NECK(1,LINES) = NECK1(1)
          NECK(2,LINES) = NECK1(2)
          JOIN(1,LINES) = NODES(I)
          JOIN(2,LINES) = NODES(I+1)
  140   CONTINUE
  150 CONTINUE
C
C     DRAW THE MAIN PLOT
C
  160 CONTINUE
      WRITE (6,*) 'TOTAL NUMBER OF ELEMENTS = ', LEMENT
      WRITE (6,*)  LINES, ' LINES GENERATED, LIMIT IS ',MXLINE
      DO 170 I = 1, LINES
        G  = Q(NECK(1,I))
        F  = P(NECK(1,I))
        FP = (F-FIRSTX)/DELTAX
        GP = (G-FIRSTY)/DELTAY
        CALL  PLOT (FP,GP,3)
        F  = P(NECK(2,I))
        G  = Q(NECK(2,I))
        FP = (F-FIRSTX)/DELTAX
        GP = (G-FIRSTY)/DELTAY
        CALL  PLOT (FP,GP,2)
  170 CONTINUE
      IF ( ISUB .GT. 0 )  THEN
C     SET UP ARRAYS FOR NEXT PLOT 
      DO 270  IS = 1, ISUB
        WRITE (6,*) 'BEGIN SUB-PLOT', IS
        XMIN = XN(IS)
        XMAX = XX(IS)
        YMIN = YN(IS)
        YMAX = YX(IS)
        XP   = PSCALE + PSPACE
        YP   = QORGIN
        IPEN = -3
C        ESTABLISH NEW PEN ORIGIN
        CALL  PLOT(XP,YP,IPEN)
        NPTS = 0
        DO 200 N = 1, LNODE
          IF ( (P(N)-XMIN)*(XMAX-P(N)) )  200,180,180
  180       IF ( (Q(N)-YMIN)*(YMAX-Q(N)) )  200,190,190
C            LIMIT SUB PLOT NODES
  190       IF ( NPTS .EQ. MXPTS )  GO TO 200
              NPTS    = NPTS + 1
              IC(N)   = NPTS
              A(NPTS) = P(N)
              B(NPTS) = Q(N)
              NAB(NPTS) = NPQ(N)
  200   CONTINUE
        NL = 0
        IF ( LINES .EQ. 0 )  GO TO 240
        DO 230 N = 1, LINES
          DO 220 J = 1, 2
            X = P(NECK(J,N))
            Y = Q(NECK(J,N))
            IF ( (X-XMIN)*(XMAX-X) )  230,210,210
  210         IF ( (Y-YMIN)*(YMAX-Y) )  230,220,220
  220     CONTINUE
          NL = NL + 1
          JOIN(1,NL) = IC(NECK(1,N))
          JOIN(2,NL) = IC(NECK(2,N))
  230   CONTINUE
  240   CONTINUE
C        SCALE THE DATA AND DRAW THE X-Y AXIS
        CALL SCALE ( A,ASCALE,NPTS,1)
        CALL SCALE ( B,BSCALE,NPTS,1)
        FIRSTA = A(NPTS+1)
        FIRSTB = B(NPTS+1)
        DELTAA = A(NPTS+2)
        DELTAB = B(NPTS+2)
        CALL AXIS (0.,0.,8HX VALUES,-8,ASCALE,AANGLE,
     1             FIRSTA,DELTAA)
        CALL AXIS (0.,0.,8HY VALUES,8,BSCALE,BANGLE,
     1             FIRSTB,DELTAB)
C        NUMBER NODAL POINTS
        DO 250  IP = 1, NPTS, NSKIP
          NSUB = IC(IP)
          IF ( NSUB .LT. 1 )  GO TO 250
C          DETERMINE POSITION IN INCHES
          X   = (A(NSUB)-FIRSTA)/DELTAA + OFFXN
          Y   = (B(NSUB)-FIRSTB)/DELTAB + OFFYN
          XYN = NAB(NSUB)
          CALL  NUMBUR (X,Y,SIZEYN,XYN,AANGLE,-1)
  250   CONTINUE
C        DRAW THE SUB-PLOT
        DO 260 I = 1, NL
          F  = A(JOIN(1,I))
          G  = B(JOIN(1,I))
          FP = (F-FIRSTA)/DELTAA
          GP = (G-FIRSTB)/DELTAB
          CALL  PLOT (FP,GP,3)
          F  = A(JOIN(2,I))
          G  = B(JOIN(2,I))
          FP = (F-FIRSTA)/DELTAA
          GP = (G-FIRSTB)/DELTAB
          CALL  PLOT (FP,GP,2)
  260   CONTINUE
        WRITE (6,*) 'END OF SUB-PLOT'
  270 CONTINUE
      ENDIF
      WRITE (6,*) 'END OF PLOT'
      CALL PLOT (0.,0.,999)
      RETURN
      END
